/// ===========================================================================
/// C= Parallel Programming Language Runtime Header
/// ===========================================================================
/// Copyright HOOPOE ProGroup, 2010-2011. All rights reserved
/// ---------------------------------------------------------------------------
/// VERSION: 0.3
/// ---------------------------------------------------------------------------
/// FILE: internal.c
/// ---------------------------------------------------------------------------

#ifndef _INTERNAL_H_
#define _INTERNAL_H_

#define _GNU_SOURCE

/**
// Include files for the project
*/

/// standard headers
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#include "C=.h"

/**
// Common structures and declarations
*/
#define CPX_CONST_MAX_SYNC_HASH 0x10000

#pragma pack(push, 1)

typedef struct
{
    int win_count;
    volatile int lock;
    volatile size_t lcnt;
    cpx_datatype_tls_context* head;
    cpx_datatype_tls_context* winner;

} cpx_datatype_sync_queue;

#pragma pack(pop)

void cpx_intrinsic_swap_exectx(cpx_datatype_execution_context* exectx);
cpx_datatype_tls_context* cpx_intrinsic_get_tlsctx();
void cpx_intrinsic_global_cleanup(int wait);
int cpx_intrinsic_create_thread();
int cpx_intrinsic_global_init();
void cpx_intrinsic_init_tls();
void cpx_intrinsic_free_tls(cpx_datatype_tls_context* tlsctx);

#endif /* _INTERNAL_H_ */
